/********************************** (C) COPYRIGHT *******************************
* File Name          : main.c
* Author             : WCH
* Version            : V1.0.0
* Date               : 2021/08/08
* Description        : Main program body.
*********************************************************************************
* Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
* Attention: This software (modified or not) and binary are used for 
* microcontroller manufactured by Nanjing Qinheng Microelectronics.
*******************************************************************************/

/*
 *@Note
 GPIO routine:
 PA0 push-pull output.

*/
#include "ch32f20x_conf.h"
#include "debug.h"
#include "bsp.h"

u32 led_time = 0;


void key_proc()
{    
    static u8 short_key_count;
    static u32 short_key_lasttime;

    
    if(key_event ==  KEYEVENT_SHORT)
    {
        key_event = 0;
        DBG_print(DBG_DEBUG,"short press "); 
    }
    else if(key_event ==  KEYEVENT_LONG)
    {
        key_event = 0;
        DBG_print(DBG_DEBUG,"event_long ");
    }

    if(short_key_count && (bsp_get_time_ms()-short_key_lasttime) > 300)
    {
        if(short_key_count == 1)
        {          
            DBG_print(DBG_DEBUG,"once key ");
        }
        else if(short_key_count == 2)
        {            
            DBG_print(DBG_DEBUG,"twice key ");
        }
        else if(short_key_count == 3)
        {
            DBG_print(DBG_DEBUG,"3 key ");
        }
        else if(short_key_count == 4)
        {
            DBG_print(DBG_DEBUG,"4 key ");
        }
        short_key_count = 0;
    }
}

void print_clk()
{
    RCC_ClocksTypeDef clks;
    RCC_GetClocksFreq(&clks);
    DBG_printf(DBG_DEBUG,"SystemClk:%d\r\n", clks.SYSCLK_Frequency);
    DBG_printf(DBG_DEBUG,"HCLK:%d\r\n", clks.HCLK_Frequency);
    DBG_printf(DBG_DEBUG,"P1CLK:%d\r\n", clks.PCLK1_Frequency );
    DBG_printf(DBG_DEBUG,"P2CLK:%d\r\n", clks.PCLK2_Frequency );
    DBG_printf(DBG_DEBUG,"adcclk:%d\r\n", clks.ADCCLK_Frequency );
}

int main( void )
{
    int loop_cnt;
    BSP_Init();    //ʼ    

    DBG_printf(DBG_DEBUG,"Bulid Time: %s %s\r\n",__DATE__, __TIME__);
    print_clk();
    Delay_Init();
    
    while(1)
    {
        Delay_Ms(10);
				DBG_printf(DBG_DEBUG,"main loop %d\r\n",loop_cnt++);
        if(bsp_get_time_ms()%1000 < 500)
        {  
						GPIO_SetBits(GPIOA, GPIO_Pin_15 );
        }
        else
        {
						GPIO_ResetBits(GPIOA, GPIO_Pin_15 );
        }        
    }
}


