#ifndef _COMMON_H_
#define _COMMON_H_

#include "types.h"



#ifndef BIT
#define BIT(x)	(1 << (x))
#endif




#define common_swap32(x)  (((x & 0xFF) << 24) | ((x & 0xFF00) << 8) | ((x & 0xFF0000) >> 8) | ((x & 0xFF000000) >> 24))
#define common_swap16(x) (((x & 0xFF) << 8) | ((x & 0xFF00) >>8))
#define common_max(a,b) (a>b)?a:b
#define common_min(a,b) (a<b)?a:b

//u32 common_swap32(u32 x);
//u16 common_swap16(u16 x);

void common_strip_2_byteip(const char *str_ip,u8 *bip);

u16 common_crc16(u8* data, u16 len);
u16 common_crc16_v(u16 init_v, u8* data, u32 len);

u16 ChkSum16(u8* data, u16 len);

int common_check_hexchar(char  c);
u8 common_char2hex(char c);
u32 common_string2hex(char * string, char* hex,u32 maxbytes);
void common_hex2string(unsigned char * hex, char *string, u16 hex_len);
bool common_isxdigit(char c);
bool common_isdigit(char c);
void common_printf_hex(u8 *buf, u16 len);
int common_str_span_substr(u8 *str, u8 chSpan,  u8 **section,int maxnum);
bool common_check_domainstr(const char * domain,u16 len);

u8 common_check_ip_empty(u8 *ip);





#endif
